"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "ACCESSIBLE", {
  enumerable: true,
  get: function () {
    return _enums.ACCESSIBLE;
  }
});
exports.default = void 0;
var _reactNative = require("react-native");
var _enums = require("./enums.js");
var _SecureStorage = _interopRequireDefault(require("./SecureStorage.js"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
const LINKING_ERROR = `The package 'react-native-fast-secure-storage' doesn't seem to be linked. Make sure: \n\n` + _reactNative.Platform.select({
  ios: "- You have run 'pod install'\n",
  default: ""
}) + "- You rebuilt the app after installing the package\n" + "- You are not using Expo Go\n";

// @ts-expect-error turboModuleProxy is not yet in the types
const isTurboModuleEnabled = global.__turboModuleProxy !== null;
const FastSecureStorageModule = isTurboModuleEnabled ?
// eslint-disable-next-line @typescript-eslint/no-var-requires, @typescript-eslint/no-require-imports
require("./spec/NativeFastSecureStorage").default : _reactNative.NativeModules.FastSecureStorage;
const FastSecureStorage = FastSecureStorageModule ? FastSecureStorageModule : new Proxy({}, {
  get() {
    throw new Error(LINKING_ERROR);
  }
});
FastSecureStorage.install();
var _default = exports.default = new _SecureStorage.default();
//# sourceMappingURL=index.js.map